unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, dglopengl,
  ExtCtrls, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Form1Create(Sender: TObject);
    procedure Form1Destroy(Sender: TObject);
    procedure Form1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
    myDC : hdc;
    myRC : HGLRC;
  public
    { public declarations }
    renderer : string;
  end; 

var
  Form1: TForm1; 
  fps : integer = 50;
  render_ready : boolean = false;
  timefactor : double;
  rotate : double;


implementation

{ TForm1 }

procedure render;
begin
rotate := rotate + timefactor*50;
if rotate > 360 then
rotate := rotate - 360;

 inc(fps);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //Farb und Tiefenpuffer lschen
 glLoadIdentity;
 gltranslatef(0,0,-5);
 glrotatef(45, 1, 0, 0);
 glrotatef(rotate,0,1,0);
 
  glcolor3f(1,0,0);      //Front
  glbegin(gl_quads);
  glvertex3f(-1, 1,1);
  glvertex3f( 1, 1,1);
  glvertex3f( 1,-1,1);
  glvertex3f(-1,-1,1);
  glend;
  
  glcolor3f(1,0.5,0);      //Back
  glbegin(gl_quads);
  glvertex3f(-1, 1,-1);
  glvertex3f( 1, 1,-1);
  glvertex3f( 1,-1,-1);
  glvertex3f(-1,-1,-1);
  glend;
  
  glcolor3f(0,1,0);     //Left Side
  glbegin(gl_quads);
  glvertex3f(-1, 1, 1);
  glvertex3f(-1,-1, 1);
  glvertex3f(-1,-1,-1);
  glvertex3f(-1, 1,-1);
  glend;
  
  glcolor3f(1,1,0);     //Right Side
  glbegin(gl_quads);
  glvertex3f( 1, 1, 1);
  glvertex3f( 1,-1, 1);
  glvertex3f( 1,-1,-1);
  glvertex3f( 1, 1,-1);
  glend;
  
  glcolor3f(0,0,1);     //Top
  glbegin(gl_quads);
  glvertex3f(-1, 1, 1);
  glvertex3f( 1, 1, 1);
  glvertex3f( 1, 1,-1);
  glvertex3f(-1, 1,-1);
  glend;

 SwapBuffers(form1.myDC);
end;

procedure TForm1.Form1Create(Sender: TObject);
begin
 initopengl;
 myDC:= GetDC(Handle);
 myRC:= CreateRenderingContext(mydc,[opDoubleBuffered],32,24,0,0,0,0);
 ActivateRenderingContext(MyDC, MyRC);
 glEnable(GL_DEPTH_TEST);
 glLoadIdentity;
 renderer := glGetString(GL_RENDERER);
 render_ready := true;
 form1.onresize(sender);
end;

procedure TForm1.Form1Destroy(Sender: TObject);
begin
 DeactivateRenderingContext;
 wglDeleteContext(myRC);
 ReleaseDC(Handle, myDC);
end;


procedure TForm1.Form1Resize(Sender: TObject);
begin
 if render_ready = true then
 begin
 glViewport(0, 0, form1.clientWidth, clientHeight);    // Setzt den Viewport fr das OpenGL Fenster
 glMatrixMode(GL_PROJECTION);        // Matrix Mode auf Projection setzen
 glLoadIdentity;                   // Reset View
 gluPerspective(45.0, clientWidth/clientHeight, 1, 1000.0);  // Perspektive den neuen Maen anpassen.
 glMatrixMode(GL_MODELVIEW);         // Zurck zur Modelview Matrix
 glLoadIdentity;
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  render;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  form1.caption := inttostr(fps) + ' FPS @ ' + renderer;
  if fps = 0 then
  fps := 1;
  
  timefactor := 1 / fps;
  fps := 0;
end;


initialization
  {$I unit1.lrs}

end.

